Index: lib/TWiki.pm
===================================================================
--- lib/TWiki.pm	(revision 1767)
+++ lib/TWiki.pm	(working copy)
@@ -2326,41 +1689,36 @@
     $value =~ s/\$mo/sprintf("%.2u",$mon+1)/geoi;
     $value =~ s/\$yea[r]?/sprintf("%.4u",$year+1900)/geoi;
     $value =~ s/\$ye/sprintf("%.2u",$year%100)/geoi;
-        
-#TODO: how do we get the different timezone strings (and when we add usertime, then what?)    
+
+#TODO: how do we get the different timezone strings (and when we add usertime, then what?)
     my $tz_str = "GMT";
     $tz_str = "Local" if ( $outputTimeZone eq "servertime" );
     $value =~ s/\$tz/$tz_str/geoi;
- 
-    return $value;        
+
+    return $value;
 }
 
-# =========================
-=pod
----++ sub handleRevisionInfo ( $web, $topic, $formatString ) ==> $value
-| $web | web and  |
-| $topic | topic to display the name for |
-| $formatString | twiki format string (like in search) |
+#| $web | web and  |
+#| $topic | topic to display the name for |
+#| $formatString | twiki format string (like in search) |
+sub _handleREVINFO {
+    my ( $params, $theTopic, $theWeb ) = @_;
 
-=cut
-sub handleRevisionInfo 
-{
-    my( $theWeb, $theTopic, $theArgs ) = @_;
-
-    my %params = extractParameters( $theArgs );
-
-    my $format = $params{"_DEFAULT"} || $params{"format"} || "r1.\$rev - \$date - \$wikiusername";
-    my $web    = $params{"web"}   || $theWeb;
-    my $topic  = $params{"topic"} || $theTopic;
+    my $format = $params->{_DEFAULT} || $params->{format}
+                 || "r1.\$rev - \$date - \$wikiusername";
+    my $web    = $params->{web} || $theWeb;
+    my $topic  = $params->{topic} || $theTopic;
     my $cgiQuery = getCgiQuery();
     my $cgiRev = "";
     $cgiRev = $cgiQuery->param('rev') if( $cgiQuery );
-    my $revnum = $cgiRev || $params{"rev"} || "";
+    my $revnum = $cgiRev || $params->{rev} || "";
+
     $revnum =~ s/r?1\.//; # cut "r" and major
 
-    my( $date, $user, $rev, $comment ) = TWiki::Store::getRevisionInfo( $web, $topic, $revnum );
-    my $wikiName     = userToWikiName( $user, 1 );
-    my $wikiUserName = userToWikiName( $user );
+    my( $date, $user, $rev, $comment ) =
+      TWiki::Store::getRevisionInfo( $web, $topic, $revnum );
+    my $wikiName     = TWiki::User::userToWikiName( $user, 1 );
+    my $wikiUserName = TWiki::User::userToWikiName( $user );
 
     my $value = $format;
     $value =~ s/\$web/$web/goi;
@@ -2371,189 +1729,58 @@
     $value =~ s/\$username/$user/goi;
     $value =~ s/\$wikiname/$wikiName/goi;
     $value =~ s/\$wikiusername/$wikiUserName/goi;
- 
-    return $value;        
+
+    return $value;
 }
 
-#AS
-# =========================
-=pod
+sub _handleENCODE {
+    my $params = shift;
 
----++ sub showError (  $errormessage  )
-
-Not yet documented.
-
-=cut
-
-sub showError
-{
-    my( $errormessage ) = @_;
-    return "<font size=\"-1\" class=\"twikiAlert\" color=\"#FF0000\">$errormessage</font>" ;
+    my $type = $params->{type};
+    my $text = $params->{_DEFAULT};
+    if ( $type && $type =~ /^entit(y|ies)$/i ) {
+        return entityEncode( $text );
+    } else {
+        return _urlEncode( $text );
+    }
 }
 
-=pod
+sub _handleSEARCH {
+    my ( $params, $theTopic, $theWeb ) = @_;
 
----++ handleToc( $text, $topic, $web, $tocAttributes )
-Parameters:
-   * $text          : the text of the current topic
-   * $topic         : the topic we are in
-   * $web           : the web we are in
-   * $tocAttributes : "Topic" [web="Web"] [depth="N"]
-Return value: $tableOfContents
+    # pass on all attrs, and add some more
+    #$params->{_callback} = undef;
+    $params->{inline} = 1;
+    $params->{baseweb} = $theTopic;
+    $params->{basetopic} = $theWeb;
+    $params->{search} = $params->{_DEFAULT} if( $params->{_DEFAULT} );
+    $params->{type} = TWiki::Prefs::getPreferencesValue( "SEARCHVARDEFAULTTYPE" ) unless( $params->{type} );
 
-Andrea Sterbini 22-08-00 / PTh 28 Feb 2001
+    use TWiki::Search;    # search engine
 
-Handles %<nop>TOC{...}% syntax.  Creates a table of contents using TWiki bulleted
-list markup, linked to the section headings of a topic. A section heading is
-entered in one of the following forms:
-   * $headingPatternSp : \t++... spaces section heading
-   * $headingPatternDa : ---++... dashes section heading
-   * $headingPatternHt : &lt;h[1-6]> HTML section heading &lt;/h[1-6]>
+    return TWiki::Search::searchWeb( %$params );
+}
 
-=cut
-
-sub handleToc
-{
-    ##     $_[0]     $_[1]      $_[2]    $_[3]
-    ## my( $theText, $theTopic, $theWeb, $attributes ) = @_;
-
-    my %params = extractParameters( $_[3] );
-
-    # get the topic name attribute
-    my $topicname = $params{"_DEFAULT"}  || $_[1];
-
-    # get the web name attribute
-    my $web = $params{"web"} || $_[2];
-    $web =~ s/\//\./g;
-    my $webPath = $web;
-    $webPath =~ s/\./\//g;
-
-    # get the depth limit attribute
-    my $depth = $params{"depth"} || 6;
-
-    #get the title attribute
-    my $title = $params{"title"} || "";
-    $title = "\n<span class=\"twikiTocTitle\">$title</span>" if( $title );
-
-    my $result  = "";
-    my $line  = "";
-    my $level = "";
-    my @list  = ();
-
-    if( "$web.$topicname" eq "$_[2].$_[1]" ) {
-        # use text from parameter
-        @list = split( /\n/, $_[0] );
-
-    } else {
-        # read text from file
-        if ( ! &TWiki::Store::topicExists( $web, $topicname ) ) {
-            return showError( "TOC: Cannot find topic \"$web.$topicname\"" );
-        }
-        my $t = TWiki::Store::readWebTopic( $web, $topicname );
-        $t =~ s/.*?%STARTINCLUDE%//s;
-        $t =~ s/%STOPINCLUDE%.*//s;
-        @list = split( /\n/, handleCommonTags( $t, $topicname, $web ) );
-    }
-
-    @list = grep { /(<\/?pre>)|($regex{headerPatternDa})|($regex{headerPatternSp})|($regex{headerPatternHt})/ } @list;
-    my $insidePre = 0;
-    my $i = 0;
-    my $tabs = "";
-    my $anchor = "";
-    my $highest = 99;
-    foreach $line ( @list ) {
-        if( $line =~ /^.*<pre>.*$/io ) {
-            $insidePre = 1;
-            $line = "";
-        }
-        if( $line =~ /^.*<\/pre>.*$/io ) {
-            $insidePre = 0;
-            $line = "";
-        }
-        if (!$insidePre) {
-            $level = $line ;
-            if ( $line =~  /$regex{headerPatternDa}/o ) {
-                $level =~ s/$regex{headerPatternDa}/$1/go;
-                $level = length $level;
-                $line  =~ s/$regex{headerPatternDa}/$2/go;
-            } elsif
-               ( $line =~  /$regex{headerPatternSp}/o ) {
-                $level =~ s/$regex{headerPatternSp}/$1/go;
-                $level = length $level;
-                $line  =~ s/$regex{headerPatternSp}/$2/go;
-            } elsif
-               ( $line =~  /$regex{headerPatternHt}/io ) {
-                $level =~ s/$regex{headerPatternHt}/$1/gio;
-                $line  =~ s/$regex{headerPatternHt}/$2/gio;
-            }
-            my $urlPath = "";
-            if( "$web.$topicname" ne "$webName.$topicName" ) {
-                # not current topic, can't omit URL
-                $urlPath = "$dispScriptUrlPath$dispViewPath$scriptSuffix/$webPath/$topicname";
-            }
-            if( ( $line ) && ( $level <= $depth ) ) {
-                $anchor = TWiki::Render::makeAnchorName( $line );
-                # cut TOC exclude '---+ heading !! exclude'
-                $line  =~ s/\s*$regex{headerPatternNoTOC}.+$//go;
-                $line  =~ s/[\n\r]//go;
-                next unless $line;
-                $highest = $level if( $level < $highest );
-                $tabs = "";
-                for( $i=0 ; $i<$level ; $i++ ) {
-                    $tabs = "\t$tabs";
-                }
-                # Remove *bold*, _italic_ and =fixed= formatting
-                $line =~ s/(^|[\s\(])\*([^\s]+?|[^\s].*?[^\s])\*($|[\s\,\.\;\:\!\?\)])/$1$2$3/g;
-                $line =~ s/(^|[\s\(])_+([^\s]+?|[^\s].*?[^\s])_+($|[\s\,\.\;\:\!\?\)])/$1$2$3/g;
-                $line =~ s/(^|[\s\(])=+([^\s]+?|[^\s].*?[^\s])=+($|[\s\,\.\;\:\!\?\)])/$1$2$3/g;
-                # Prevent WikiLinks
-                $line =~ s/\[\[.*?\]\[(.*?)\]\]/$1/g;  # '[[...][...]]'
-                $line =~ s/\[\[(.*?)\]\]/$1/ge;        # '[[...]]'
-                $line =~ s/([\s\(])($regex{webNameRegex})\.($regex{wikiWordRegex})/$1<nop>$3/g;  # 'Web.TopicName'
-                $line =~ s/([\s\(])($regex{wikiWordRegex})/$1<nop>$2/g;  # 'TopicName'
-                $line =~ s/([\s\(])($regex{abbrevRegex})/$1<nop>$2/g;    # 'TLA'
-                # create linked bullet item, using a relative link to anchor
-                $line = "$tabs* <a href=\"$urlPath#$anchor\">$line</a>";
-                $result .= "\n$line";
-            }
-        }
-    }
-    if( $result ) {
-        if( $highest > 1 ) {
-            # left shift TOC
-            $highest--;
-            $result =~ s/^\t{$highest}//gm;
-        }
-        $result = "<div class=\"twikiToc\">$title$result\n</div>";
-        return $result;
-
-    } else {
-        return showError("TOC: No TOC in \"$web.$topicname\"");
-    }
+# Format an error for inline inclusion in HTML
+sub _inlineError {
+    my( $errormessage ) = @_;
+    return "<font size=\"-1\" class=\"twikiAlert\" color=\"red\">$errormessage</font>" ;
 }
 
-# =========================
 =pod
 
----++ sub getPublicWebList ()
+---++ getPublicWebList ()
+Return public web list, i.e. exclude hidden webs, but include current web
 
-Not yet documented.
-
 =cut
 
-sub getPublicWebList
-{
-    # FIXME: Should this go elsewhere?
-    # (Not in Store because Store should not be dependent on Prefs.)
-
+sub getPublicWebList {
     if( ! @publicWebList ) {
-        # build public web list, e.g. exclude hidden webs, but include current web
-        my @list = &TWiki::Store::getAllWebs( "" );
+        my @list = TWiki::Store::getAllWebs();
         my $item = "";
         my $hidden = "";
         foreach $item ( @list ) {
-            $hidden = &TWiki::Prefs::getPreferencesValue( "NOSEARCHALL", $item );
-            # exclude topics that are hidden or start with . or _ unless current web
+            $hidden = TWiki::Prefs::getPreferencesValue( "NOSEARCHALL", $item );
             if( ( $item eq $TWiki::webName  ) || ( ( ! $hidden ) && ( $item =~ /^[^\.\_]/ ) ) ) {
                 push( @publicWebList, $item );
             }
@@ -2562,58 +1789,66 @@
     return @publicWebList;
 }
 
-# =========================
 =pod
 
----++ sub expandVariablesOnTopicCreation ( $theText, $theUser, $theWikiName, $theWikiUserName )
+---++ expandVariablesOnTopicCreation ( $theText, $theUser, $theWikiName, $theWikiUserName )
+Expand limited set of variables during topic creation. These are variables
+expected in templates that must be statically expanded in new content.
 
-Expand limited set of variables with a topic during topic creation
+The expanded variables are:
+| =%DATE%= | Signature-format date |
+| =%USERNAME%= | Base login name |
+| =%WIKINAME%= | Wiki name |
+| =%WIKIUSERNAME%= | Wiki name with prepended web |
+| =%URLPARAM%= | Parameters to the current CGI query |
+| =%NOP%= | No-op |
 
 =cut
 
 sub expandVariablesOnTopicCreation {
   my ( $theText, $theUser, $theWikiName, $theWikiUserName ) = @_;
 
-  my $today = formatTime(time(), "\$day \$mon \$year", "gmtime");
-  $theUser         = $userName                     unless $theUser;
-  $theWikiName     = userToWikiName( $theUser, 1 ) unless $theWikiName;
-  $theWikiUserName = userToWikiName( $theUser )    unless $theWikiUserName;
+  $theUser = $userName unless $theUser;
+  $theWikiName = TWiki::User::userToWikiName( $theUser, 1 )
+    unless $theWikiName;
+  $theWikiUserName = TWiki::User::userToWikiName( $theUser )
+    unless $theWikiUserName;
 
-  $theText =~ s/%DATE%/$today/go;
-  $theText =~ s/%USERNAME%/$theUser/go;                     # "jdoe"
-  $theText =~ s/%WIKINAME%/$theWikiName/go;                 # "JonDoe"
-  $theText =~ s/%WIKIUSERNAME%/$theWikiUserName/go;         # "Main.JonDoe"
-  $theText =~ s/%URLPARAM{(.*?)}%/&handleUrlParam($1)/geo;  # expand URL parameters
-  $theText =~ s/%NOP{.*?}%//gos;  # Remove filler: Use it to remove access control at time of
-  $theText =~ s/%NOP%//go;        # topic instantiation or to prevent search from hitting a template
+  $theText =~ s/%DATE%/&_handleDATE()/ge;
+  $theText =~ s/%USERNAME%/$theUser/go;               # "jdoe"
+  $theText =~ s/%WIKINAME%/$theWikiName/go;           # "JonDoe"
+  $theText =~ s/%WIKIUSERNAME%/$theWikiUserName/go; # "Main.JonDoe"
+  $theText =~ s/%URLPARAM{(.*?)}%/&_handleURLPARAM(\%{extractParameters($1)})/geo;
+  # Remove filler: Use it to remove access control at time of
+  # topic instantiation or to prevent search from hitting a template
+  # SMELL: this expansion of %NOP{}% is different to the default
+  # which retains content.....
+  $theText =~ s/%NOP{.*?}%//gos;
+  $theText =~ s/%NOP%//go;
 
   return $theText;
 }
 
-# =========================
-=pod
+sub _handleWEBLIST {
+    return _webOrTopicList( 1, @_ );
+}
 
----++ sub handleWebAndTopicList (  $theAttr, $isWeb  )
+sub _handleTOPICLIST {
+    return _webOrTopicList( 0, @_ );
+}
 
-Not yet documented.
+sub _webOrTopicList {
+    my( $isWeb, $params ) = @_;
 
-=cut
-
-sub handleWebAndTopicList
-{
-    my( $theAttr, $isWeb ) = @_;
-
-    my %params = extractParameters( $theAttr );
-
-    my $format    = $params{"_DEFAULT"}  || $params{"format"} || "";
+    my $format = $params->{_DEFAULT} || $params->{format};
     $format .= '$name' unless( $format =~ /\$name/ );
-    my $separator = $params{"separator"} || "\n";
-    my $web       = $params{"web"}       || "";
-    my $webs      = $params{"webs"}      || "public";
-    my $selection = $params{"selection"} || "";
+    my $separator = $params->{separator} || "\n";
+    my $web = $params->{web} || "";
+    my $webs = $params->{webs} || "public";
+    my $selection = $params->{selection} || "";
     $selection =~ s/\,/ /g;
     $selection = " $selection ";
-    my $marker    = $params{"marker"}    || 'selected="selected"';
+    my $marker    = $params->{marker} || 'selected="selected"';
 
     my @list = ();
     if( $isWeb ) {
@@ -2622,16 +1857,16 @@
             if( $aweb eq "public" ) {
                 push( @list, getPublicWebList() );
             } elsif( $aweb eq "webtemplate" ) {
-                push( @list, grep { /^\_/o } &TWiki::Store::getAllWebs( "" ) );
+                push( @list, grep { /^\_/o } TWiki::Store::getAllWebs() );
             } else{
-                push( @list, $aweb ) if( &TWiki::Store::webExists( $aweb ) );
+                push( @list, $aweb ) if( TWiki::Store::webExists( $aweb ) );
             }
         }
     } else {
         $web = $webName if( ! $web );
-        my $hidden = &TWiki::Prefs::getPreferencesValue( "NOSEARCHALL", $web );
+        my $hidden = TWiki::Prefs::getPreferencesValue( "NOSEARCHALL", $web );
         if( ( $web eq $TWiki::webName  ) || ( ! $hidden ) ) {
-            @list = &TWiki::Store::getTopicNames( $web );
+            @list = TWiki::Store::getTopicNames( $web );
         }
     }
     my $text = "";
@@ -2651,26 +1886,15 @@
     return $text;
 }
 
-# =========================
-=pod
+sub _handleURLPARAM {
+    my $params = shift;
 
----++ sub handleUrlParam (  $theArgs  )
+    my $param     = $params->{_DEFAULT};
+    my $newLine   = $params->{newline};
+    my $encode    = $params->{encode};
+    my $multiple  = $params->{multiple};
+    my $separator = $params->{separator} || "\n";
 
-Not yet documented.
-
-=cut
-
-sub handleUrlParam
-{
-    my( $theArgs ) = @_;
-
-    my %params    = extractParameters( $theArgs );
-    my $param     = $params{"_DEFAULT"}  || "";
-    my $newLine   = $params{"newline"}   || "";
-    my $encode    = $params{"encode"}    || "";
-    my $multiple  = $params{"multiple"}  || "";
-    my $separator = $params{"separator"} || "\n";
-
     my $value = "";
     if( $cgiQuery ) {
         if( $multiple ) {
